# coding: utf-8

"""
    STACKIT Server Backup Management API

    API endpoints for Server Backup Operations on STACKIT Servers.

    The version of the OpenAPI document: 1.0
    Contact: support@stackit.de
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501 docstring might be too long

from __future__ import annotations

import json
import pprint
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing_extensions import Self


class BackupVolumeBackupsInner(BaseModel):
    """
    BackupVolumeBackupsInner
    """

    id: Optional[StrictStr] = None
    last_restored_at: Optional[StrictStr] = Field(default=None, alias="lastRestoredAt")
    last_restored_volume_id: Optional[StrictStr] = Field(default=None, alias="lastRestoredVolumeId")
    size: Optional[StrictInt] = None
    status: Optional[StrictStr] = None
    volume_id: Optional[StrictStr] = Field(default=None, alias="volumeId")
    __properties: ClassVar[List[str]] = ["id", "lastRestoredAt", "lastRestoredVolumeId", "size", "status", "volumeId"]

    @field_validator("status")
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(
            ["creating", "available", "deleting", "error", "restoring", "error_deleting", "error-creating"]
        ):
            raise ValueError(
                "must be one of enum values ('creating', 'available', 'deleting', 'error', 'restoring', 'error_deleting', 'error-creating')"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BackupVolumeBackupsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BackupVolumeBackupsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "id": obj.get("id"),
                "lastRestoredAt": obj.get("lastRestoredAt"),
                "lastRestoredVolumeId": obj.get("lastRestoredVolumeId"),
                "size": obj.get("size"),
                "status": obj.get("status"),
                "volumeId": obj.get("volumeId"),
            }
        )
        return _obj
